<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	session_register("ds");
	$ds = ldap_connect($config[server]);
	if ($ds)
	{
		if (ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3))
		{
			$r = ldap_bind($ds, "cn=".$auth_user.",".$config[base], $auth_passwd);
			if ($r && ($auth_passwd != ""))
			{
				$connection = true;
			}
			else
			{
				print("### Cannot Bind to LDAP Server as Administrator ###");
				$connection = false;
			}
		}
		else
		{
			echo "### Failed to set protocol version to 3 ###";
			$connection = false;
			include("disconnect.php");
			exit();
		}
	}
	else
	{
		print("### Cannot find LDAP Server ###");
		$connection = false;
		exit();
	}

?>
