<?php
/*

Copyright (c)2002-2003 DuckCorp(tm) and RtpNet(tm)



This file is part of LMS.

LMS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

LMS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LMS; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

	$object="Object";
	unset($b);
	unset($c);
	$b = ldap_explode_dn($loc, 1);
	for ($i=0; $i<count($b)-2; $i++)
	{
		if ($c=array_search($b[$i], $config[containers]))
		{
			$object=$c;
			break;
		}
	}

	unset($a);

	$userslist[0] = array();
	$userslist[1] = array();
	$userslist[2] = array();
	$userslist[3] = array();
	$userslist[4] = array();
	$userslist[5] = array();
	$sr = ldap_search($ds, $config[base], "objectClass=posixAccount", array("cn", "uid", "uidnumber", "gidnumber", "description"));
	if ($sr)
	{
		// Only in CVS
		//ldap_sort($ds,$sr,"");
		
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$userslist[0][$i] = $a[$i][uid][0];
				$userslist[1][$i] = $a[$i][uidnumber][0];
				$userslist[2][$i] = $a[$i][gidnumber][0];
				$userslist[3][$i] = utf8_decode($a[$i][description][0]);
				unset($b);
				$b = ldap_explode_dn($a[$i][dn], 0);
				array_splice($b, 0, 2);
				$userslist[4][$i] = implode(",",$b);
				$userslist[5][$i] = $a[$i][cn][0];
			}
			array_multisort($userslist[0], $userslist[1], $userslist[2], $userslist[3], $userslist[4], $userslist[5]);
		}
	}
	ldap_free_result($sr);
	
	$groupslist[0] = array();
	$groupslist[1] = array();
	$groupslist[2] = array();
	$groupslist[3] = array();
	$sr = ldap_search($ds, $config[base], "objectClass=posixGroup", array("cn", "gidnumber", "description"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$groupslist[0][$i] = $a[$i]["cn"][0];
				$groupslist[1][$i] = $a[$i]["gidnumber"][0];
				$groupslist[2][$i] = utf8_decode($a[$i]["description"][0]);
				unset($b);
				$b = ldap_explode_dn($a[$i][dn], 0);
				array_splice($b, 0, 2);
				$groupslist[3][$i] = implode(",", $b);
			}
			array_multisort($groupslist[0], $groupslist[1], $groupslist[2], $groupslist[3]);
		}
	}
	ldap_free_result($sr);
	
	$hostslist = array();
	$commonhostslist = array();
	$serverhostslist = array();
	$sr = ldap_search($ds, $config[base], "objectClass=".$config[objectclass_commonhost], array("cn"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		$j=0;
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$hostslist[$i] = $a[$i][cn][0];
				$commonhostslist[$i] = $a[$i][cn][0];
			}
			sort($commonhostslist);
			$j=$i;
		}
	}
	ldap_free_result($sr);
	$sr = ldap_search($ds, $config[base], "objectClass=".$config[objectclass_serverhost], array("cn"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
			{
				$hostslist[$i+$j] = $a[$i][cn][0];
				$serverhostslist[$i] = $a[$i][cn][0];
			}
			sort($serverhostslist);
			sort($hostslist);
		}
	}
	ldap_free_result($sr);

	$adslgroupslist = array();
	$sr = ldap_search($ds, $config[base], "objectClass=".$config[objectclass_adslgroup], array("cn"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		$j=0;
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
				$adslgroupslist[$i] = $a[$i][cn][0];
			sort($hostslist);
		}
	}
	ldap_free_result($sr);

	$serviceslist = array();
	$sr = ldap_search($ds, $config[base], "objectClass=".$config[objectclass_service], array("cn"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		$j=0;
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
				$serviceslist[$i] = $a[$i][cn][0];
			sort($serviceslist);
		}
	}
	ldap_free_result($sr);

	$serviceuserslist = array();
	$sr = ldap_search($ds, $config[base], "objectClass=".$config[objectclass_serviceuser], array("uid"));
	if ($sr)
	{
		$a = ldap_get_entries($ds, $sr);
		$nb = ldap_count_entries($ds, $sr);
		$j=0;
		if($nb)
		{
			for ($i=0; $i<$nb; $i++)
				$serviceuserslist[$i] = $a[$i][uid][0];
			sort($serviceuserslist);
		}
	}
	ldap_free_result($sr);
?>
